/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.kenai.com
 * SCM: https://kenai.com/hg/openbluesky~src
 *
 **********************************************************************************************************************/
package it.tidalwave.hierarchy.spi.simple;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import it.tidalwave.util.Id;
import it.tidalwave.util.spi.FinderSupport;
import it.tidalwave.hierarchy.Finder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public abstract class HFinderSupport<T> extends FinderSupport<T, Finder<T>> implements Finder<T>
  {
    @CheckForNull
    protected Id id;

    public HFinderSupport (final @Nonnull String name)
      {
        super(name);
      }

    @Override @Nonnull
    public HFinderSupport clone() 
      {
        final HFinderSupport<T> clone = (HFinderSupport<T>)super.clone();
        clone.id = this.id;
        return clone;
      }

    @Override @Nonnull
    public Finder<T> id (final @Nonnull Id id)
      {
        final HFinderSupport<T> clone = clone();
        clone.id = id;
        return clone;
      }

    @Override @Nonnull
    public Finder<T> id (final @Nonnull String id)
      {
        return id(new Id(id));
      }

    @Override @Nonnull
    public Finder<T> boundToType (final @Nonnull Class<?> type)
      {
        final HFinderSupport<T> clone = clone();
        // FIXME: todo
        return clone;
      }

    @Override @Nonnull
    public Finder<T> boundTo (final @Nonnull Object boundObject)
      {
        final HFinderSupport<T> clone = clone();
        // FIXME: todo
        return clone;
      }

    @Override @Nonnull
    public <X> Finder<X> ofType (final @Nonnull Class<X> type)
      {
        return (Finder<X>)super.ofType(type);
      }
  }
